#ifndef M98_M_H 
#define M98_M_H

/*
   $Log: m.h,v $
   Revision 1.8.2.4  2008/06/20 17:02:05  kraemer
   platform stuff

   Revision 1.8.2.3  2006/01/07 12:35:52  kraemer
   OSX sync

   Revision 1.8.2.2  2005/03/16 00:55:00  kraemer
   *** empty log message ***

   Revision 1.8.2.1  2005/03/15 14:25:58  kraemer
   *** empty log message ***

   Revision 1.8  2004/07/27 16:51:51  kraemer
   vintpolmt1() added

   Revision 1.7  2000/04/03 12:31:38  kraemer
   c2* and other prototypes

   Revision 1.6  1999/12/16 12:42:55  kraemer
   prototypes added

   Revision 1.5  1999/02/02 19:56:24  kraemer
   function prototypes added (random generators)

   Revision 1.4  1997/12/15 17:28:41  kraemer
   branches for native gammafunction, nan declarations

   Revision 1.3  1997/07/10 17:26:10  kraemer
   *** empty log message ***

   Revision 1.2  1997/06/16 18:15:51  kraemer
   more prototypes

*/

#include <float.h>
#include <math.h>

#ifndef min
#define min(a,b) ( (a) < (b) ) ? (a) : (b)
#endif

#ifndef max
#define max(a,b) ( (a) > (b) ) ? (a) : (b)
#endif
 
#if defined(AMIGA)

 
#if defined(M881)

#include <m68881.h>
#undef  floor
#define floor floor

#elif defined(MFFP)
#elif defined(MIEEE)
#else
#error You loose, choose an appropriate floating point option ! 
#endif             /* end M881/MFFP/MIEEE */

 

 
#if defined(MFFP)
 
#undef DBL_MAX
#undef FLT_MAX
#undef DBL_MIN
#undef FLT_MIN
#define DBL_MAX 9.2233717E18
#define FLT_MAX 9.2233717E18
/*#define DBL_MIN 2.7105E-20 */
/*#define FLT_MIN 2.7105E-20 */
 
union UNDDUL { unsigned long ul; double dd; };

static union UNDDUL uDBL_MIN = { 0x80000000 };
#undef DBL_MIN
#define DBL_MIN (uDBL_MIN.dd)
#define FLT_MIN DBL_MIN

static union UNDDUL uDBL_EPSILON = { 0x8000002A };
#undef DBL_EPSILON
#define DBL_EPSILON (uDBL_EPSILON.dd)
#undef FLT_EPSILON
#define FLT_EPSILON DBL_EPSILON
 
static union UNDDUL uDBL_QNAN = { 0x0000007F };
#define DBL_QNAN (uDBL_QNAN.dd)
 
  
union UNRRUL { unsigned long ul; float rr; };
static union UNRRUL uFLT_QNAN = { 0x0000007F };
#define FLT_QNAN (uFLT_QNAN.rr)

static union UNDDUL uDBL_INF = { 0x0000007F };
#define DBL_INF (uDBL_INF.dd)

static union UNRRUL uFLT_INF = { 0x0000007F };
#define FLT_INF (uFLT_INF.rr)

#define FLT_SNAN FLT_QNAN
#define DBL_SNAN DBL_QNAN


#define ISDBLSKIP(x) ( ((x)==DBL_QNAN) )
#define ISFLTSKIP(x) ( ((x)==FLT_QNAN) )
 
  
#else
  
  
union UNDDUL { unsigned long ulv[2]; double dd; };

#ifndef DBL_QNAN
#ifndef _QNAN
static union UNDDUL uDBL_QNAN = { 0x7FFFFFFF, 0xFFFFFFFF };
#define DBL_QNAN (uDBL_QNAN.dd)
#else
#define DBL_QNAN _QNAN
#endif
#endif

#ifndef DBL_SNAN
#ifndef _SNAN
static union UNDDUL uDBL_SNAN = { 0x7FF7FFFF, 0xFFFFFFFF };
#define DBL_SNAN (uDBL_SNAN.dd)
#else
#define DBL_SNAN _SNAN
#endif
#endif
 
union UNRRUL { unsigned long ul; float rr; };

#ifndef FLT_QNAN
#ifndef _QNAN
static union UNRRUL uFLT_QNAN = { 0x7FFFFFFF };
#define FLT_QNAN (uFLT_QNAN.rr)
#else
#define FLT_QNAN _QNAN
#endif
#endif

#ifndef FLT_SNAN
#ifndef _SNAN
static union UNRRUL uFLT_SNAN = { 0x7FBFFFFF };
#define FLT_SNAN (uFLT_SNAN.rr)
#else
#define FLT_SNAN _SNAN
#endif
#endif

static union UNDDUL uDBL_INF = { 0x7FF00000, 0x00000000 };
#define DBL_INF (uDBL_INF.dd)
static union UNRRUL uFLT_INF = { 0x7F800000 };
#define FLT_INF (uFLT_INF.rr)


int isdblskip(double);
#define ISDBLSKIP(x) isdblskip(x)
int isfltskip(float);
#define ISFLTSKIP(x) isfltskip(x)

#endif



#ifndef isfinite
#define isfinite(x) \
    ( (sizeof(x) == sizeof(float)  ) ? isfiniter(x) \
   :  (sizeof(x) == sizeof(double) ) ? isfinited(x) \
   :                                   isfiniteq(x))
int isfiniter( float );
int isfinited( double );    
int isfiniteq( double );    
#endif

#ifndef M_PI
#define M_PI PI
#endif
#ifndef M_PI_2
#define M_PI_2 PID2
#endif
#ifndef M_PI_4
#define M_PI_4 PID4
#endif
#ifndef M_2PI
#define M_2PI (PI+PI)
#endif
#ifndef M_LN2
#define M_LN2 log(2.0E0)
#endif

#ifndef M_E
#define M_E 2.71828182845904523536028747135266250 
#endif

                                      /* these exist */
#define POW2_EXISTS
#define COT_EXISTS
 

#elif defined(_AIX) || defined(__hpux) || defined(sun) || defined(__mips) || \
      defined(__linux__) || defined(__osf__)
 
 
 
union UNDDUL { unsigned long long ull; double dd; };

#ifndef DBL_QNAN
#ifndef _QNAN
static union UNDDUL uDBL_QNAN = { 0x7FF8000000000000ULL };
#define DBL_QNAN (uDBL_QNAN.dd)
#else
#define DBL_QNAN _QNAN
#endif
#endif

#ifndef FLT_QNAN
static unsigned int rQNAN = 0x7FC00000;
#define FLT_QNAN   (*((float *) (&rQNAN)))
#endif
 
union UNRRUL { unsigned long ul; float rr; };

/*#define ISDBLSKIP(x) ( ((x)==DBL_QNAN) ) */
/*#define ISFLTSKIP(x) ( ((x)==FLT_QNAN) ) */
#define ISDBLSKIP(x) ( isnan(x) )
#define ISFLTSKIP(x) ( isnan(x) )

#ifndef isfinited
#define isfinited finite
#endif
 
#define PI M_PI
#ifndef M_2PI
#define M_2PI (PI+PI)
#endif
 
#define ASINH_EXISTS
#define ACOSH_EXISTS
#define ATANH_EXISTS 

#elif defined(__EMX__)  || defined(__APPLE_CC__) 
 
 
union UNDDUL { unsigned long long ull; double dd; };

#ifndef DBL_QNAN
#ifndef _QNAN
static union UNDDUL uDBL_QNAN = { 0x7FF8000000000000ULL };
#define DBL_QNAN (uDBL_QNAN.dd)
#else
#define DBL_QNAN _QNAN
#endif
#endif
 
union UNRRUL { unsigned long ul; float rr; };
#ifndef FLT_QNAN
#ifndef _QNAN
static union UNRRUL uFLT_QNAN = { 0x7FC00000};
#define FLT_QNAN (uFLT_QNAN.rr)
#else
#define FLT_QNAN _QNAN
#endif
#endif

#define ISDBLSKIP(x) ( __isnan(x) )
#define ISFLTSKIP(x) ( __isnanf(x) )
#define isinf(x) ( !isfinite(x) )
 
#define PI M_PI
#ifndef M_2PI
#define M_2PI (PI+PI)
#endif
 
 
#elif ( defined(MVS) || defined(mvs) )
 
 
#define M_PI 3.141592653589793238462643E0
#define PI M_PI
#define min(a,b) ( (a) < (b) ) ? (a) : (b)
#define max(a,b) ( (a) > (b) ) ? (a) : (b)
 
#else
#error You loose, you should not use this computer
#endif
/*
#define DBL_SKIP -DBL_MAX
#define FLT_SKIP -FLT_MAX
*/
#define DBL_SKIP DBL_QNAN
#define FLT_SKIP FLT_QNAN

/*
   --- special function macros
*/
#ifndef POW2_EXISTS
#define  pow2(x) pow(2.0E0,x)
#endif

#define pow10(x) pow(1.0E1,x)

#ifndef LOG2_EXISTS
#define log2(x) ( log(x) / M_LN2 )           
#endif

#ifndef COT_EXISTS
#define  cot(x) 1E0/tan(x)
#endif

#define SIND(deg) (\
                  ( fmod(deg,180.) ==   0 ) ? (0.0E0) : \
                  ( fmod(deg-90.,360.) == 0 ) ? (1E0) : \
                  ( fmod(deg+90.,360.) == 0 ) ? (-1E0) : \
                  ( fmod(deg,360.) ==  30 ) ? (0.5) : \
                  ( fmod(deg,360.) == 150 ) ? (0.5) : \
                  ( fmod(deg,360.) ==  45 ) ? sqrt(0.5) : \
                  ( fmod(deg,360.) == 135 ) ? sqrt(0.5) : \
                  ( fmod(deg,360.) ==  60 ) ? sqrt(0.75) : \
                  ( fmod(deg,360.) == 120 ) ? sqrt(0.75) : \
                  ( fmod(deg,360.) == 210 ) ? (-0.5) : \
                  ( fmod(deg,360.) == 330 ) ? (-0.5) : \
                  ( fmod(deg,360.) == 225 ) ? -sqrt(0.5) : \
                  ( fmod(deg,360.) == 315 ) ? -sqrt(0.5) : \
                  ( fmod(deg,360.) == 240 ) ? -sqrt(0.75) : \
                  ( fmod(deg,360.) == 300 ) ? -sqrt(0.75) : \
                  ( fmod(deg,360.) == -30 ) ? (-0.5) : \
                  ( fmod(deg,360.) ==-150 ) ? (-0.5) : \
                  ( fmod(deg,360.) == -45 ) ? -sqrt(0.5) : \
                  ( fmod(deg,360.) ==-135 ) ? -sqrt(0.5) : \
                  ( fmod(deg,360.) == -60 ) ? -sqrt(0.75) : \
                  ( fmod(deg,360.) ==-120 ) ? -sqrt(0.75) : \
                  ( fmod(deg,360.) ==-210 ) ? (0.5) : \
                  ( fmod(deg,360.) ==-330 ) ? (0.5) : \
                  ( fmod(deg,360.) ==-225 ) ? sqrt(0.5) : \
                  ( fmod(deg,360.) ==-315 ) ? sqrt(0.5) : \
                  ( fmod(deg,360.) ==-240 ) ? sqrt(0.75) : \
                  ( fmod(deg,360.) ==-300 ) ? sqrt(0.75) : \
                  sin( (deg) * PI / 180E0 ) ) 

#define COSD(deg) (\
                  ( fmod(deg,360.) ==   0 ) ? (1.0E0) : \
                  ( fmod(deg-180.,360.) ==   0 ) ? (-1.0E0) : \
                  ( fmod(deg-90.,180.) == 0 ) ? (0E0) : \
                  ( fmod(deg,360.) ==  60 ) ? (0.5) : \
                  ( fmod(deg,360.) == 300 ) ? (0.5) : \
                  ( fmod(deg,360.) ==  45 ) ? sqrt(0.5) : \
                  ( fmod(deg,360.) == 315 ) ? sqrt(0.5) : \
                  ( fmod(deg,360.) ==  30 ) ? sqrt(0.75) : \
                  ( fmod(deg,360.) == 330 ) ? sqrt(0.75) : \
                  ( fmod(deg,360.) == 120 ) ? (-0.5) : \
                  ( fmod(deg,360.) == 240 ) ? (-0.5) : \
                  ( fmod(deg,360.) == 135 ) ? -sqrt(0.5) : \
                  ( fmod(deg,360.) == 225 ) ? -sqrt(0.5) : \
                  ( fmod(deg,360.) == 150 ) ? -sqrt(0.75) : \
                  ( fmod(deg,360.) == 210 ) ? -sqrt(0.75) : \
                  ( fmod(deg,360.) ==-120 ) ? (-0.5) : \
                  ( fmod(deg,360.) ==-240 ) ? (-0.5) : \
                  ( fmod(deg,360.) ==-225 ) ? -sqrt(0.5) : \
                  ( fmod(deg,360.) ==-135 ) ? -sqrt(0.5) : \
                  ( fmod(deg,360.) ==-150 ) ? -sqrt(0.75) : \
                  ( fmod(deg,360.) ==-210 ) ? -sqrt(0.75) : \
                  ( fmod(deg,360.) == -60 ) ? (0.5) : \
                  ( fmod(deg,360.) ==-300 ) ? (0.5) : \
                  ( fmod(deg,360.) == -45 ) ? sqrt(0.5) : \
                  ( fmod(deg,360.) ==-315 ) ? sqrt(0.5) : \
                  ( fmod(deg,360.) == -30 ) ? sqrt(0.75) : \
                  ( fmod(deg,360.) ==-330 ) ? sqrt(0.75) : \
                  cos( (deg) * PI / 180E0 ) )

#define TAND(deg) (\
                  ( fmod(deg,180.) == 0 ) ? (0) : \
                  ( fmod(deg-90.,180.) == 0 ) ? (DBL_SKIP) : \
                  ( fmod(deg-45.,180.) == 0 ) ? 1.0 : \
                  ( fmod(deg+45.,180.) == 0 ) ? -1.0 : \
                  ( fmod(deg-30.,180.) == 0 ) ? sqrt(3.0)/3.0 : \
                  ( fmod(deg+30.,180.) == 0 ) ? -sqrt(3.0)/3.0 : \
                  ( fmod(deg-60.,180.) == 0 ) ? sqrt(3.0) : \
                  ( fmod(deg+60.,180.) == 0 ) ? -sqrt(3.0) : \
                  tan( (deg) * PI / 180E0 ) )

#define COTD(deg) (\
                  ( fmod(deg,180.) == 0 ) ? (DBL_SKIP) : \
                  ( fmod(deg-90.,180.) == 0 ) ? (0) : \
                  ( fmod(deg-45.,180.) == 0 ) ? 1.0 : \
                  ( fmod(deg+45.,180.) == 0 ) ? -1.0 : \
                  ( fmod(deg-30.,180.) == 0 ) ? sqrt(3.0) : \
                  ( fmod(deg+30.,180.) == 0 ) ? -sqrt(3.0) : \
                  ( fmod(deg-60.,180.) == 0 ) ? sqrt(3.0)/3. : \
                  ( fmod(deg+60.,180.) == 0 ) ? -sqrt(3.0)/3. : \
                  cot( (deg) * PI / 180E0 ) )

#define ASIND(arg) (\
                  ( (arg) ==   0 ) ? (0.0E0) : \
                  ( (arg) == 0.5 ) ? (30) : \
                  ( (arg) == 1.0E0 ) ? (90) : \
                  ( (arg) == -0.5 ) ? (-30) : \
                  ( (arg) == -1.0E0 ) ? (-90) : \
                  asin( (arg) ) * 180E0 / PI ) 

#define ACOSD(arg) (\
                  ( (arg) ==   0 ) ? (90) : \
                  ( (arg) == 0.5 ) ? (60) : \
                  ( (arg) == 1.0E0 ) ? (0) : \
                  ( (arg) == -0.5 ) ? (120) : \
                  ( (arg) == -1.0E0 ) ? (180) : \
                  acos( (arg) ) * 180E0 / PI ) 

#define ATAND(arg) (\
                  ( (arg) ==   0 ) ? (0) : \
                  atan( (arg) ) * 180E0 / PI )

#define ATAN2D(y,x) (\
                  ( ( (y) == 0E0 ) && ( (x) == (0.0E0) ) ) ? (DBL_QNAN) : \
                  ( ( (y)  > 0E0 ) && ( (x) == (0.0E0) ) ) ? (90) : \
                  ( ( (y)  < 0E0 ) && ( (x) == (0.0E0) ) ) ? (-90) : \
                  ( ( (y) == 0E0 ) && ( (x)  > (0.0E0) ) ) ? (  0) : \
                  ( ( (y) == 0E0 ) && ( (x)  < (0.0E0) ) ) ? (180) : \
                  ( ( (y)  > 0E0 ) && ( (x) == (y) ) ) ? (45) : \
                  ( ( (y)  > 0E0 ) && ( (x) == -(y) ) ) ? (135) : \
                  ( ( (y)  < 0E0 ) && ( (x) == (y) ) ) ? (-135) : \
                  ( ( (y)  < 0E0 ) && ( (x) == -(y) ) ) ? (-45) : \
                  atan2( y, x ) * 180E0 / PI )

#ifndef ASINH_EXISTS
#define asinh(x) log((x)+sqrt((x)*(x)+1.0E0))
#endif
#ifndef ACOSH_EXISTS
#define acosh(x) log((x)+sqrt((x)*(x)-1.0E0))
#endif
#ifndef ATANH_EXISTS
#define atanh(x) log((1.0E0+(x))/(1.0E0-(x)))*0.5
#endif


/*
   --- action flags and constants
*/
                                   /* for the v1dlap*() routine(s) */
enum { V1DLAP_ERR=-1, V1DLAP_FULL, V1DLAP_PART,
       V1DLAP_NONE, V1DLAP_TOUCH, V1DLAP_EXACT };
                                   /* for (vector) comparisons */
enum { GT=1, LT, NE, EQ, GE, LE, };

/*
   --- FORTRAN entries
*/
#if defined(_AIX) || defined(ultrix)
void vcvdx_( double *, double *, int *, int *, long *, int *);
void vwwdx_( double *, double *, double *, int *, long *, int *);
void vnt1d_( double *, int *, double *, int *, int *, double *);
void vnv2dd_( double *, double *, int *, double *, int *, int *, double *);
#endif
#if defined(MVS) || defined(mvs)
void vcvdx ( double *, double *, int *, int *, long *, int *);
void vwwdx ( double *, double *, double *, int *, long *, int *);
void vnt1d ( double *, int *, double *, int *, int *, double *);
void vnv2dd ( double *, double *, int *, double *, int *, int *, double *);
#endif
/*
   --- C entries
*/
#if defined(MVS) || defined(mvs)
int vcvdx_( double *, double , int , int , long *);
int vwwdx_( double *, double *, double *, int, long * );
void vnt1d_( double *, int, double *, int, int, double *);
void vnv2dd_( double *, double *, int, double *, int, int, double *);
#define vcvdx  vcvdx_
#define vwwdx  vwwdx_
#define vnt1d  vnt1d_
#define vnv2dd vnv2dd_
#else
int vcvdx( double *, double , int , int , long *);
int vwwdx( double *, double *, double *, int, long * );
void vnt1d( double *, int, double *, int, int, double *);
void vnv2dd( double *, double *, int, double *, int, int, double *);
#endif


 
int splloc( double *, double *, int, double * );
int splper( double *, double *, int, double * );
int splnat( double *, double *, double *,      int, double *, double *);

int Diag5 ( double *, double *, double *, double *, double *, double *, 
int );
int Diag5c( double *, double *, double *, double *, double *, double *, int );
int Diag3c( double *, double *, double *, double *, int );
int matinv( double *, int *, int *, int, double * );
int InvMat( double *, int, int *, int *, double * );



int vintpolmt1d( double **, int, double **, int, int );
int vintpol1d( double *, int, int, double **, int, int, double *, int );
int vintpol1r( float  *, int, int, float  **, int, int, float  *, int ); 
void vnt2d( double *, double *, int, double *, int, int, double *);
long vbind( double *, int, int, double *, int, long *, int );
int vnear( double *, long, long, double *, long, long *, long );


double vtrapz( double *, int, double *, int, double *, int, int );
double romint( 
               double (*)( double, double [], int ),
	       double [],        /* [nPar] */
	       int,
	       double [2],
	       int,
	       double,
	       double [],       /* [nHalf+1] */
	       int
             );


int fndpeak(double *, double *, double *, double *, int, double [6],
            double *, int );
int   vlsqpol( double *, double *, double *, double *, int,
               double *, double *, double *, int, double *
             );
 
                                      /* random generators */
void vrnsd  ( unsigned long *, double, double, int, double * );
void vrnsl  ( unsigned long *, long, long, int, long * );
void vrnvd  ( unsigned long *, double *, double *, int, double * );
void vrpoisd( unsigned long *, double, int, double * );
void vrnorsd( unsigned long *, double, double, int, double * );
double _prn(void);
double _rnorm(void);

void vrnesd( unsigned long *, unsigned long *, double, double, long, double [] );
void vrnevd( unsigned long *, unsigned long *, double [], double [], long, double [] );
void vrnesl( unsigned long *, unsigned long *, long  , long  , long, long   [] );
void vrnnsd( unsigned long *, unsigned long *, double, double, long, double [] );
void vrnpsd( unsigned long *, unsigned long *, double,         long, double [] );
double vrnmind(void);



int vleg    ( double *, int, double *, int, double *, int, double *, int );
int vlegevn ( double *, int, double *, int, double *, int, double *, int );
int vlegodd ( double *, int, double *, int, double *, int, double *, int );
int vlegn   ( double *, int, double *, int, double *, int, double *, int );
int vlegevnn( double *, int, double *, int, double *, int, double *, int );
int vlegoddn( double *, int, double *, int, double *, int, double *, int );

int vexpon   ( double *, int, double *, int, double *, int, double *, int );
int vpoly    ( double *, int, double *, int, double *, int, double *, int );
int vlortz   ( double *, int, double *, int, double *, int, double *, int );
int vgauss   ( double *, int, double *, int, double *, int, double *, int );
int vgaussint( double *, int, double *, int, double *, int, double *, int );


void vellipse( double *, int, double * );
void vscequ( double *, double *, int, double *, int, int );
int vmom( double *, int, double *, int, int, double [2][2], double *, int );
void vtrafo2 ( double *, double [2][3], int, double * );
void vitrafo2( short *, double [2][3], int, double * );
void vtrafo2i( double *, double [2][3], int, short * );
long vrampd( double, double, double *, int, int );
void vramp ( double, double, double *, int, int );
void vslope( double *, int, double *, int, double *, int, int );


long vsqrt ( double *, long, double *, long, long);
long vlog  ( double *, long, double *, long, long);
long vlog10( double *, long, double *, long, long);
long vlog2 ( double *, long, double *, long, long);
long vexp  ( double *, long, double *, long, long);
long v10tox( double *, long, double *, long, long);
long vsin  ( double *, long, double *, long, long);
long vcos  ( double *, long, double *, long, long);
long vcosd ( double *, long, double *, long, long);
long vtan  ( double *, long, double *, long, long);
long vasin ( double *, long, double *, long, long);
long vacos ( double *, long, double *, long, long);
long vacosd( double *, long, double *, long, long);
long vatan ( double *, long, double *, long, long);
long vsinh ( double *, long, double *, long, long);
long vcosh ( double *, long, double *, long, long);
long vtanh ( double *, long, double *, long, long);
long vasinh ( double *, long, double *, long, long);
long vacosh ( double *, long, double *, long, long);
long vatanh ( double *, long, double *, long, long);
long svpow( double, double *, long, double *, long, long);
long vpow  ( double *, long, double *, long, double *, long, long);
long vspow( double *, long, double, double *, long, long);
long vspowi(double *, long,    int, double *, long, long);


long vadd( double *, long, double *, long, double *, long, long);
long vsub( double *, long, double *, long, double *, long, long);
long vmul( double *, long, double *, long, double *, long, long);
long vdiv( double *, long, double *, long, double *, long, long);
long vabs  ( double *, long, double *, long, long);
long vneg  ( double *, long, double *, long, long);
long vsadd( double *, long, double, double *, long, long);
long vsmul( double *, long, double, double *, long, long);
long svdiv( double, double *, long, double *, long, long);
long svsub( double, double *, long, double *, long, long);
long vasm ( double *, int, double *, int, double, double *, int, int);
long vsma ( double *, int, double, double *, int, double *, int, int);
long vsmsa( double *, int, double, double, double *, int, int);
/* long vsiadd( double *, long, int, double *, long, long); */


long maxv( double *, long, double *, long *, long);
long minv( double *, long, double *, long *, long);
long vmin( double *, int, double *, int, double *, int, int);
long vmax( double *, int, double *, int, double *, int, int);
long vsmax( double *, int, double, double *, int, int);
long vclip( double *, long, double, double, double *, long, long);
long viclip( short *, long, short, short, short *, long, long);
int vcvdb( double *, double , int , int , long *);
int  vwsdb ( double *, int, double *, int, long * );
int  vwsdx ( double *, int, double *, int, long * );
int  vwsd2x( double *, int, double *, int, double *, int, long * );
int  vwsd3b( double [3][2], int, int, double *, int, double *, int, double *, long * );
int  vwbd2b( double [], int, int, int, double *, int, double *, int, long * );
int v1dlapd( double [2], double [2] );


void vfill( double, double *, long, long );
void vifill( long, long *, long, long );
void vmov  ( double *, long, double *, long, long);
void vimov ( long *, long, long *, long, long);
void vmrot ( double *, long, long, double *, long, long);
void vgthx( long *, int, int, ... );
int vnodup( double *, int, int, double *, int );
void vshsrtd ( double **, int, int, int );
void SrtShell( double **, int, int );


void vi2d( short *, long, double *, long, long);
void vl2d(  long *, long, double *, long, long);
long vd2l( double *, long,  long *, long, long);
long vd2i( double *, long,  short *, long, long);
 
/*
   --- OS-dependent math functions
*/
#if defined(__EMX__)
double erf(double);
double j0(double);
double j1(double);
double jn(int,double);
double y0(double);
double y1(double);
double yn(int,double);
#endif

#if defined(AMIGA) 
double erf(double);
double j0(double);
double j1(double);
double jn(int,double);
double y0(double);
double y1(double);
double yn(int,double);
#endif

#if defined(sun) || defined(__hpux)
#elif defined(AMIGA) || defined(_AIX) || defined(__EMX__) || defined(__osf__) \
                     || defined(__mips) || (__linux__)   || defined(__APPLE_CC__)
double lgamma_r( double, int *);
#else
#error What about a native lgamma_r function ??
#endif
/*
   --- more special math functions
*/
double js0(double);
double js1(double);
double jsn(int,double);
double ys0(double);
double ys1(double);
double ysn(int,double);

double poisson( double, double );

double beta    ( double, double );
double betainc ( double, double, double );
double gamma   ( double );
double gammainc( double, double );
double erfinv  ( double );
                                      /* */
double tDist   ( double, int );
double tProb   ( double, int );
double tQuantil( double, int );
double chiDist   ( double, int );
double chiProb   ( double, int );
double chiQuantil( double, int );
                                      /* */
double e1( double );
/*
double sincos( double, double [2] );
*/ 
double powi( double, int );
double powd( double, double );

double asind( double );
double acosd( double );
double atand( double );
double  sind( double );
double  cosd( double );
double  tand( double );
 
                                      /* number conversion functions */
int c2d ( const char *, double *);
int cn2d( const char *, int, double *);
int c2vd ( const char *, double *, int, int );
int cn2vd( const char *, int, double *, int, int );

int c2s ( const char *, float  *);
int cn2s( const char *, int, float  *);
int c2vs ( const char *, float *, int, int );
int cn2vs( const char *, int, float *, int, int );

int c2ul( const char *, unsigned long * ); 
int cn2ul( const char *, int, unsigned long * );
int c2l ( const char *, long *);
int cn2l( const char *, int, long *);
int c2vl ( const char *, long *, int, int );
int cn2vl( const char *, int, long *, int, int );

int c2w ( const char *, short *);
int cn2w( const char *, int, short *);
int c2vw ( const char *, short *, int, int );
int cn2vw( const char *, int, short *, int, int ); 
 
int c2b ( const char *, signed char *);
int cn2b( const char *, int, signed char *);
int c2vb ( const char *, signed char *, int, int );
int cn2vb( const char *, int, signed char *, int, int ); 
 
int x2ul( const char *, unsigned long * );
int x2l( const char *, long * );
int x2w( const char *, short * );
int x2b( const char *, signed char * );

double *c2vdalc( const char *, double, int * );
double *cn2vdalc( const char *, int, double, int * );
  
                                      /* common error handling for vector
                                      functions... */
                                      /* error flag bits (lower bits keep array index 0..nn-1) */
#define ERRVMATH_ERROR   0xC0000000
#define ERRVMATH_ERRMASK 0xC0000000
#define ERRVMATH_SYS     0x80000000  
#define ERRVMATH_BADADDR 0x40000000  
#define ERRVMATH_DOMAIN  0x80000000  /* domain error ( sqrt(<0) etc ) */ 
#define ERRVMATH_ZDVD    0x40000000  /* zero-divide */

#endif
